\ ===================================================================
\  File: Network-Support.FTH
\
\  This file contains words that support the transmission of commands
\  to, and reception of responses from the simulation, over a TCP/IP
\  connection.
\
\   BUFFER: SERVER$ ( -- a$z )   A buffer to hold the server's IP
\      address.  The address is stored as a zero-terminated string.
\
\   : MAKE-CONNECTION ( -- t )   Attempts to connect with the flight
\      simulation.  Stores the socket handle in SESSION-SOCKET,
\      and returns TRUE on success.
\
\   : CLOSE ( -- )   Closes the connection and returns the socket
\      to the OS.
\
\   : SEND-COMMAND ( a,# -- t )   Takes the address of a buffer and
\      the number of bytes in the buffer and sends the data to the
\      simulation.  Returns TRUE on success.
\
\   : RECEIVE-RESPONSE ( a,# -- t )   Takes the address of a buffer
\      and the maximum number of bytes to write into it.  Waits for
\      a message from the simulation and stores the data into the
\      buffer.  Returns TRUE on success, and stores the number of
\      characters received in variable RECEIVED.
\
\              Copyright (C) 2014 Richard C. Wagner
\  This file is offered under the GNU General Public License.
\  Please see the license statement at the end of the file.
\ ===================================================================

\ A buffer to hold the zero-terminated server IP address string.
17 CONSTANT SERVER$SIZE
SERVER$SIZE BUFFER: SERVER$ ( -- a$z )

\ Set the initial IP address to "localhost".
Z" localhost" SERVER$ ZMOVE

VARIABLE       SESSION-SOCKET
20248 CONSTANT SESSION-PORT

: MAKE-CONNECTION ( -- t )
   SERVER$ ZCOUNT SESSION-PORT TCPCONNECT 0= SWAP SESSION-SOCKET ! ;

: CLOSE ( -- )   SESSION-SOCKET @ CLOSESOCKET DROP ;

: SEND-COMMAND ( a,# -- t )   SESSION-SOCKET @ WRITESOCK 0= NIP ;

VARIABLE RECEIVED

: RECEIVE-RESPONSE ( a,# -- t )   SESSION-SOCKET @ READSOCK
   0= SWAP RECEIVED ! ;


\ ====================  License Statement  ==========================
\ This program is free software: you can redistribute it and/or modify
\ it under the terms of the GNU General Public License as published by
\ the Free Software Foundation, either version 3 of the License, or
\ (at your option) any later version.
\
\ This program is distributed in the hope that it will be useful,
\ but WITHOUT ANY WARRANTY; without even the implied warranty of
\ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
\ GNU General Public License for more details.
\
\ You should have received a copy of the GNU General Public License
\ along with this program.  If not, see <http://www.gnu.org/licenses/>.
\ ===================================================================