\ ===================================================================
\  File: Sim-Client.FTH
\
\  This is the load file for the flight simulation client.
\
\              Copyright (C) 2014 Richard C. Wagner
\  This file is offered under the GNU General Public License.
\  Please see the license statement at the end of the file.
\ ===================================================================

\ ==================  VFX Forth Library Files  ======================
\  These files are included with the MicroProcessor Engineering Ltd.
\  VFX Forth system.
\ ===================================================================

INCLUDE "C:\Program Files (x86)\VfxStandard\Lib\NDP387.FTH"
                               \ VFX hardware floating point words

\ Set the interpreter to accept dotted floats and to display 4 digits.
   CHAR , DP-CHAR 1+ C!  4 PLACES

INCLUDE Windows-Globals.FTH    \ Windows function definitions
INCLUDE "C:\Program Files (x86)\VfxStandard\Lib\Win32\Genio\SOCKETIO.FTH"
                               \ VFX network socket words



\ ===================  Basic Simulation Client  =====================
\  These files comprise a client program for the flight simulation.
\  You can build your own system on top of them by using the commands
\  provided by Commands.FTH.  See Open-Loop.FTH for examples.
\ ===================================================================

INCLUDE Network-Support.FTH    \ Raw TCP/IP client words
INCLUDE Data-Values.FTH        \ Structures to hold aircraft data
INCLUDE Commands.FTH           \ Commands to the simulation


\ ======================  High-Level Control  =======================
\  Include your own high level control words here.
\ ===================================================================

INCLUDE ASCII-Float.FTH        \ ASCII floating point output words
INCLUDE Open-Loop.FTH          \ Data output and aircraft control


\ ==================  Graphical User Interface  =====================

INCLUDE CLIENT-GUI.FTH         \ Windows GUI


\ ====================  License Statement  ==========================
\ This program is free software: you can redistribute it and/or modify
\ it under the terms of the GNU General Public License as published by
\ the Free Software Foundation, either version 3 of the License, or
\ (at your option) any later version.
\
\ This program is distributed in the hope that it will be useful,
\ but WITHOUT ANY WARRANTY; without even the implied warranty of
\ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
\ GNU General Public License for more details.
\
\ You should have received a copy of the GNU General Public License
\ along with this program.  If not, see <http://www.gnu.org/licenses/>.
\ ===================================================================